var spatnePokusy = 0;
class table{
  constructor(obal,id_tabulky){                 //adopce_rodic
    let tabulka = document.createElement('table');
    this.rodic = obal;
    this.id = tabulka.id = id_tabulky;
    obal.innerHTML = "";
    this.sirka = 8;
    this.vyska = 10;
    this.head_popisky = ["Třída","Září","Říjen","Listopad","Prosinec","Leden","Celkový prodej","Tržba"];
    this.sloupec_popisky = ["6. A","6. B","7. A","7. B","8. A","Celkem","Průměr","Minimum","Maximum"];  
    
    this.hledam = new Array(3);
    this.pocet_nalezenych = 0;
    this.pocet_hledanych = 3;
    
    this.data = new Data(7);
    this.data.set_hidden(this);   
  
    this.rodic.appendChild(tabulka);
  }
 
  create(){
    let radek, bunka;
    
    let tabulka = document.getElementById(this.id);
    tabulka.setAttribute("class","cap3");
    let tmp_int = 0;
    for(let i = 0; i < this.vyska; i++){
    radek = tabulka.insertRow(i);
      for(let x = 0; x < this.sirka; x++){
        if(i==0){
          bunka = document.createElement('th');
          bunka.innerHTML = this.head_popisky[x];
        }else{
          bunka = radek.insertCell(x);
          if(x==0)
            bunka.innerHTML = this.sloupec_popisky[x+(i-1)];
          else{
            tmp_int = this.data.getValue(i-1,x-1);
            if(x < (this.sirka-1))
              bunka.innerHTML = tmp_int;
            else{
              tmp_int = Math.round(tmp_int);
              bunka.appendChild(document.createTextNode(tmp_int.toLocaleString()+" Kč"));
            }              
          }           
        }
        radek.appendChild(bunka);
      }
    }
  } 
  
  addListener(data){
    for(let x = 0; x<3;x++)
    document.getElementById("hledam_"+x).addEventListener("change", function(){
      kontrola_vstupu(this,x,data);
});
  
  } 
}

class Data{
  constructor(velikost){
    this.data = new Array(velikost);
    for(let i=0;i<5;i++){
      this.data[i] = vytvor_pole(7,21,249,false);
    }   
    
    //suma za pro danou tridu
    for(let x=0;x<5;x++){
      this.data[x][5] = 0;
      for(let i=0;i<5;i++)
        this.data[x][5] += this.data[x][i];      
    }
    //trzba pro danou tridu
    for(let x=0;x<5;x++)
      this.data[x][6] = this.data[x][5] * 22;    
      
    //suma za mesic, prumer,minimum a maximum
    for(let x=0;x<5;x++)
      this.data[x+5] = new Array(6);
      
    let suma, minimum, maximum;
    for(let x=0;x<7;x++){
      suma = maximum = 0;   
      minimum = Number.MAX_SAFE_INTEGER;
      for(let i=0;i<5;i++){
        suma += this.data[i][x];
        if(minimum > this.data[i][x])
          minimum = this.data[i][x];
        if(maximum < this.data[i][x])
          maximum = this.data[i][x];
      }
      this.data[5][x] = suma;
      this.data[6][x] = Math.round((suma/5)*100)/100;  
      if(x<6)  
        this.data[6][x] = this.data[6][x].toString().replace(".",",");
      this.data[7][x] = minimum;
      this.data[8][x] = maximum;
    }    
  } 
  
  //davam tam celou tabulku kvuli pristupu k popiskum mesicu, funkci, aj.
  set_hidden(tabulka){
    //mesic
    let rand_int = random_int(1,5);
    let hodnota_check = tabulka.head_popisky[rand_int];
    tabulka.hledam[0] = hodnota_check;
    tabulka.head_popisky[rand_int] = '<input type="text" maxlength="9" id="hledam_0" onChange="kontrola_vstupu(this,0,'+tabulka+')" />';
  
    //mat. funkce
    rand_int = random_int(5,8);
    hodnota_check = tabulka.sloupec_popisky[rand_int];
    tabulka.hledam[1] = hodnota_check;
    tabulka.sloupec_popisky[rand_int] = '<input type="text" maxlength="9" id="hledam_1" />';
    
    //cislo
    let sloupec = random_int(1,5);
    let radek = random_int(0,5);
    hodnota_check = tabulka.data.getValue(radek,sloupec);
    tabulka.hledam[2] = hodnota_check;
    let tmp_string = '<input type="text" maxlength="10" id="hledam_2" onChange="" />';
    tabulka.data.setValue(radek,sloupec,tmp_string);
  }
  
  getValue(x,y){
    return this.data[x][y];
  }
  
  setValue(x,y,value){
    this.data[x][y] = value;
  }
} 

/**
 * Funkce, ktera overuje vepsanou hodnotu s hodnotou predpokladanou. Non-case-sensitive. 
 * prvek - element, ktery se kontroluje
 * hodnota - string, co by tam melo byt   
 */  
function kontrola_vstupu(prvek, index, tabulka){
  var vstup = prvek.value.toString();
  vstup = vstup.toLowerCase();
  vstup = vstup.charAt(0).toUpperCase() + vstup.slice(1);
  vstup = vstup.trim();
  //zeptat se na možné varianty 
  if(vstup == tabulka.hledam[index]){                
    //sedi to a zapisuji + menim barvu
    prvek.value = vstup;
    prvek.disabled = true;
    prvek.style.color = "Green";
    tabulka.pocet_nalezenych++;
    var hodnoceni = document.getElementById('score');
    if(tabulka.pocet_nalezenych == tabulka.pocet_hledanych){    
      hodnoceni.innerHTML = "";
      if(spatnePokusy == 0)
        print_modal("modal", "ok", "Ty jo, na první dobrou?! Bezvadné!");
      else
        print_modal("modal", "neutr", "Údaje jsi doplnil správně, příště to dáš určitě už bez chyby!");
    }
    else{
      hodnoceni.innerHTML = 'Ještě nám chybí dopsat <span class="red">'+(tabulka.pocet_hledanych-tabulka.pocet_nalezenych)+'</span> ze '+tabulka.pocet_hledanych+' údajů.';
    }
  }
  else{
    //nesedi to a menim barvu
    spatnePokusy++;
    prvek.style.color = "Red";
  }
}

   
var tabulka = new table(adopce_rodic, "adopce");
tabulka.create();
tabulka.addListener(tabulka);